import threading
import time
import os
import sqlite3
from comicapi import comicarchive
from comicapi.issuestring import IssueString
from urllib import parse

os.environ["UNRAR_LIB_PATH"] = 'C:\\Program Files (x86)\\UnrarDLL\\UnRAR.dll'

COMICS_DIRECTORY = "F:\\comics"

print(b'\xE2\x80\x93'.decode("utf-8", "replace"))
#os._exit(0)

def get_comics():
	meta = []
	i = 0
	for root, dirs, files in os.walk(COMICS_DIRECTORY):
		for f in files:
			if f.endswith(".cbr"):
				path = os.path.join(root, f)
				print(path)
				if not og_comic_path_in_db(path):
					archive = comicarchive.ComicArchive(path, default_image_path="C:\\Users\\Matthew\\Documents\\MyPrograms\\Websites\\rpi web interface\\rpiWebApp\\static\\icon.png")
					meta.append((path, archive.readCIX()))
	return meta

'''
thread = threading.Thread(target=get_comics, args=())
thread.daemon = True
print('start')
thread.start()
time.sleep(3)'''


DATABASE = "C:\\Users\\Matthew\\Documents\\MyPrograms\\Websites\\rpi web interface\\database.db"

db = sqlite3.connect(DATABASE)


def get_db():
	global db
	return db


def initialize_db():
	get_db().execute("""CREATE TABLE IF NOT EXISTS "comics" (
	"path"	TEXT UNIQUE,
	"tagOrigin"	TEXT,
	"series"	TEXT,
	"issue" REAL,
	"issueText" TEXT,
	"title"	TEXT,
	"publisher"	TEXT,
	"month"	INTEGER,
	"year"	INTEGER,
	"day"	INTEGER,
	"issueCount"	INTEGER,
	"volume"	TEXT,
	"genre"	TEXT,
	"language"	TEXT,
	"comments"	TEXT,
	"volumeCount"	INTEGER,
	"criticalRating"	TEXT,
	"country"	TEXT,
	"alternateSeries"	TEXT,
	"alternateNumber"	TEXT,
	"alternateCount"	INTEGER,
	"imprint"	TEXT,
	"notes"	TEXT,
	"webLink"	TEXT,
	"format"	TEXT,
	"manga"	TEXT,
	"blackAndWhite"	TEXT,
	"pageCount"	TEXT,
	"maturityRating"	TEXT,
	"storyArc"	TEXT,
	"seriesGroup"	TEXT,
	"scanInfo"	TEXT,
	"characters"	TEXT,
	"teams"	TEXT,
	"locations"	TEXT,
	"id"	INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT UNIQUE
)""")
	get_db().execute("""CREATE TABLE IF NOT EXISTS "credits" (
	"id"	INTEGER NOT NULL,
	"role"	TEXT,
	"name"	TEXT,
	"primary"	INTEGER NOT NULL
)""")
	get_db().execute("CREATE INDEX IF NOT EXISTS path_index ON comics(path);")
	get_db().commit()


def add_comics(meta):
	data = []
	for info in meta:
		issue = IssueString(info[1].issue).asFloat()
		data.append((info[0], info[1].tagOrigin, info[1].series, (issue or -1), info[1].issue, info[1].title, info[1].publisher,
					info[1].month, info[1].year, info[1].day, info[1].issueCount, info[1].volume, info[1].genre,
					info[1].language, info[1].comments, info[1].volumeCount, info[1].criticalRating, info[1].country,
					info[1].alternateSeries, info[1].alternateNumber, info[1].alternateCount, info[1].imprint,
					info[1].notes, info[1].webLink, info[1].format, info[1].manga, info[1].blackAndWhite,
					info[1].pageCount, info[1].maturityRating, info[1].storyArc, info[1].seriesGroup, info[1].scanInfo,
					info[1].characters, info[1].teams, info[1].locations))
	get_db().executemany(
		"""INSERT into comics(path, tagOrigin, series, issue, issueText, title, publisher,
		month, year, day, issueCount, volume, genre, language, comments, volumeCount,
		criticalRating, country, alternateSeries, alternateNumber, alternateCount, imprint,
		notes, webLink, format, manga, blackAndWhite, pageCount, maturityRating, storyArc,
		seriesGroup, scanInfo, characters, teams, locations)
		VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)""",
		data)
	get_db().commit()


def og_comic_path_in_db(path):
	result = get_db().execute("SELECT EXISTS(SELECT * FROM comics WHERE path=?) LIMIT 1;", (path,))
	if result.fetchone()[0] == 1:
		return True
	return False


def comic_path_in_db(path):
	result = get_db().execute("SELECT path FROM comics WHERE path LIKE ?", [path.encode("utf8")])
	if result.fetchone():
		return True
	return False


#initialize_db()
#add_comics(get_comics())


#for row in get_db().execute('SELECT * FROM comics ORDER BY series'):
#	print(row)


#test_path = "/usb/storage/media/Comics/Marvel/Marvel Super Hero Adventures - Spider-Man – Web Designers 2019/Marvel Super Hero Adventures - Spider-Man – Web Designers #001 (2019).cbr"

#print(comic_path_in_db(test_path))
